#ifndef RC5_H
#define RC5_H

#include <stdint.h>
#include <avr/io.h>

#define F_OSC	3686400L

#define RC5TIME 	1.778e-3		// 1.778msec
#define POLL_FREQ	(F_OSC / 8 / 128) 	// timer mit F_OSC/8, reload mit 256
#define xRC5_IN		PIND
#define xRC5		PD6
#define PULSE_MIN	(uint8_t)(POLL_FREQ * RC5TIME * 0.4 + 0.5)
#define PULSE_1_2	(uint8_t)(POLL_FREQ * RC5TIME * 0.8 + 0.5)
#define PULSE_MAX	(uint8_t)(POLL_FREQ * RC5TIME * 1.2 + 0.5)

extern uint16_t rc5_data;
extern uint16_t rc5_tmp;
extern uint8_t  rc5_bit;                               // bit value
extern uint8_t  rc5_time;                              // count bit time
extern void rc5_poll(void);

#endif
